package de.tudresden.inf.st.mquat.solving.genetic;

import de.tudresden.inf.st.mquat.generator.ScenarioDescription;
import de.tudresden.inf.st.mquat.generator.ScenarioGenerator;
import de.tudresden.inf.st.mquat.jastadd.model.Root;
import de.tudresden.inf.st.mquat.jastadd.model.Solution;
import de.tudresden.inf.st.mquat.solving.BenchmarkableSolver;
import de.tudresden.inf.st.mquat.solving.SolvingException;

import java.util.concurrent.TimeUnit;

public class GeneticMain {

  public static void main(String[] args) {

    ScenarioGenerator generator = new ScenarioGenerator(new ScenarioDescription(1,1, 0,1,0,2, 10, 10, 1, 1, 0));


    Root model = generator.generate();


    System.out.println("Problem has an initial solution with objective " + generator.getInitialSolution().computeObjective());

    BenchmarkableSolver solver = new GeneticSolver(GeneticSolver.SelectorType.NSGA2, 100,100);

    solver.setTimeout(30, TimeUnit.SECONDS);



    try {
      Solution solution = solver.solve(model);

      System.out.println("Solution is valid: " + solution.isValid());

      System.out.println("Found solution with objective " + solution.computeObjective());

    } catch (SolvingException e) {
      e.printStackTrace();
    }

  }

}
